//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  Silver
#property indicator_color4  LimeGreen
#property indicator_color5  LimeGreen
#property indicator_color6  PaleVioletRed
#property indicator_color7  PaleVioletRed
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_width3  2
#property indicator_width4  3
#property indicator_width5  3
#property indicator_width6  3
#property indicator_width7  3

//
//
//
//
//

extern int    StoKPeriod = 14;
extern int    StoSlowing =  3;
extern int    StoPrice   =  0;
extern int    LongPeriod = 50;
extern double Percent    = 95;

//
//
//
//
//

double sto[];
double leu[];
double led[];
double stoUa[];
double stoUb[];
double stoDa[];
double stoDb[];
double state[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,leu);
   SetIndexBuffer(1,led);
   SetIndexBuffer(2,sto);
   SetIndexBuffer(3,stoUa);
   SetIndexBuffer(4,stoUb);
   SetIndexBuffer(5,stoDa);
   SetIndexBuffer(6,stoDb);
   SetIndexBuffer(7,state);
      IndicatorShortName("Stochastic ("+StoKPeriod+","+StoSlowing+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   if (state[limit] ==-1) CleanPoint(limit,stoDa,stoDb);
   if (state[limit] == 1) CleanPoint(limit,stoUa,stoUb);

   for(i=limit; i>=0; i--) 
   {
      sto[i] = iStochastic(NULL,0,StoKPeriod,1,StoSlowing,MODE_SMA,StoPrice,MODE_MAIN  ,i);
            double hi = sto[ArrayMaximum(sto,LongPeriod,i)];
            double lo = sto[ArrayMinimum(sto,LongPeriod,i)];
            double rn = hi-lo;
      leu[i]   = lo+rn*Percent/100.0;
      led[i]   = hi-rn*Percent/100.0;
      stoUa[i] = EMPTY_VALUE;
      stoUb[i] = EMPTY_VALUE;
      stoDa[i] = EMPTY_VALUE;
      stoDb[i] = EMPTY_VALUE;
      state[i] = state[i+1];
         if (sto[i] > leu[i])                    state[i] =  1;
         if (sto[i] < led[i])                    state[i] = -1;
         if (sto[i] < leu[i] && sto[i] > led[i]) state[i] =  0;
         if (state[i] == 1) PlotPoint(i,stoUa,stoUb,sto);
         if (state[i] ==-1) PlotPoint(i,stoDa,stoDb,sto);
   }      
   return(0);
}
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}